﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Reflection;

namespace howto_reflection_list_systeminfo_properties
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Make column headers.
            lvwProperties.Columns.Clear();
            lvwProperties.Columns.Add("Property", 200,
                HorizontalAlignment.Left);
            lvwProperties.Columns.Add("Value", 225,
                HorizontalAlignment.Left);

            // List the SystemInformation class's properties.
            object property_value;
            PropertyInfo[] property_infos = typeof(SystemInformation).GetProperties(
                BindingFlags.FlattenHierarchy |
                BindingFlags.Instance |
                BindingFlags.NonPublic |
                BindingFlags.Public |
                BindingFlags.Static);
            foreach (PropertyInfo info in property_infos)
            {
                string name = info.Name;
                string value = "";

                // See if it's an array.
                if (!info.PropertyType.IsArray)
                {
                    // It's not an array.
                    if (info.CanRead) property_value = info.GetValue(this, null);
                    else property_value = "---";

                    if (property_value == null)
                        value = "<null>";
                    else
                        value = property_value.ToString();
                }
                else
                {
                    // It is an array.
                    name += "[]";
                    value = "<array>";
                }

                ListViewMakeRow(lvwProperties, name, value);
            }

            this.Text += " (" + lvwProperties.Items.Count + " properties)";
        }

        // Make a ListView row.
        private void ListViewMakeRow(ListView lvw, String item_title, params string[] subitem_titles)
        {
            // Make the item.
            ListViewItem new_item = lvw.Items.Add(item_title);

            // Make the sub-items.
            for (int i = subitem_titles.GetLowerBound(0); i <= subitem_titles.GetUpperBound(0); i++)
            {
                new_item.SubItems.Add(subitem_titles[i]);
            }
        }
    }
}
